'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = MuiTable;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _MultiGrid = require('react-virtualized/dist/commonjs/MultiGrid');

var _MultiGrid2 = _interopRequireDefault(_MultiGrid);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Table = require('@material-ui/core/Table');

var _Table2 = _interopRequireDefault(_Table);

var _TableCell = require('@material-ui/core/TableCell');

var _TableCell2 = _interopRequireDefault(_TableCell);

var _TableFooter = require('@material-ui/core/TableFooter');

var _TableFooter2 = _interopRequireDefault(_TableFooter);

var _TablePagination = require('@material-ui/core/TablePagination');

var _TablePagination2 = _interopRequireDefault(_TablePagination);

var _TableSortLabel = require('@material-ui/core/TableSortLabel');

var _TableSortLabel2 = _interopRequireDefault(_TableSortLabel);

var _styles = require('@material-ui/core/styles');

var _reactDraggable = require('react-draggable');

var _reactDraggable2 = _interopRequireDefault(_reactDraggable);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FOOTER_BORDER_HEIGHT = 1;

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    table: {
      boxSizing: 'border-box',

      '& .topLeftGrid': {
        backgroundColor: theme.palette.grey[theme.palette.type === 'dark' ? 800 : 200],
        borderBottom: '2px solid ' + theme.palette.divider,
        borderRight: '2px solid ' + theme.palette.divider,
        color: theme.palette.text.secondary,
        fontSize: theme.typography.pxToRem(12),

        // Hide scrollbars on Chrome/Safari/IE
        '&::-webkit-scrollbar': {
          display: 'none'
        },
        '-ms-overflow-style': 'none'
      },

      '& .topRightGrid': {
        backgroundColor: theme.palette.grey[theme.palette.type === 'dark' ? 800 : 200],
        borderBottom: '2px solid ' + theme.palette.divider,
        color: theme.palette.text.secondary,
        fontSize: theme.typography.pxToRem(12),

        // Hide scrollbars on Chrome/Safari/IE
        '&::-webkit-scrollbar': {
          display: 'none'
        },
        '-ms-overflow-style': 'none'
      },

      '& .bottomLeftGrid': {
        backgroundColor: theme.palette.grey[theme.palette.type === 'dark' ? 800 : 200],
        borderRight: '2px solid ' + theme.palette.divider,
        color: theme.palette.text.secondary,
        fontSize: theme.typography.pxToRem(13),

        // Hide scrollbars on Chrome/Safari/IE
        '&::-webkit-scrollbar': {
          display: 'none'
        },
        '-ms-overflow-style': 'none'
      },

      '& .bottomRightGrid': {
        color: theme.palette.text.primary,
        fontSize: theme.typography.pxToRem(13),
        outline: 'none' // See: https://github.com/bvaughn/react-virtualized/issues/381
      }
    },
    cell: {
      boxSizing: 'border-box',
      display: 'flex',
      alignItems: 'center'
    },
    cellClickable: {
      cursor: 'pointer'
    },
    cellSelected: {
      backgroundColor: theme.palette.grey[theme.palette.type === 'dark' ? 900 : 100]
    },
    cellHovered: {
      backgroundColor: theme.palette.grey[theme.palette.type === 'dark' ? 800 : 200]
    },
    cellDisabled: {
      opacity: 0.5
    },
    cellContents: {
      width: '100%',
      whiteSpace: 'nowrap',
      overflow: 'hidden',
      textOverflow: 'ellipsis'
    },
    cellHeader: {
      fontSize: theme.typography.pxToRem(12),
      fontWeight: theme.typography.fontWeightMedium,
      color: theme.palette.text.secondary
    },
    cellInLastColumn: {
      paddingRight: theme.spacing(3)
    },
    cellInLastRow: {
      borderBottom: 'none'
    },
    footer: {
      borderTop: FOOTER_BORDER_HEIGHT + 'px solid ' + theme.palette.divider
    },
    dragHandle: {
      flex: '0 0 16px',
      zIndex: 2,
      cursor: 'col-resize',
      color: '#0085ff'
    },
    DragHandleActive: {
      color: '#0b6fcc',
      zIndex: 3
    },
    DragHandleIcon: {
      flex: '0 0 12px',
      display: 'flex',
      flexDirection: 'column',
      justifyContent: 'center',
      alignItems: 'center'
    }
  };
});

var calculateWidths = function calculateWidths(_ref) {
  var resizable = _ref.resizable,
      Columns = _ref.columns;

  var widths = [];
  if (resizable) {
    var initialWidth = 1;
    var columns = [];
    Columns.forEach(function (c) {
      if (c.width) {
        widths[c.name] = 0.1;
        initialWidth = initialWidth - 0.1;
      } else {
        columns.push(c);
      }
    });
    columns.forEach(function (c) {
      widths[c.name] = initialWidth / columns.length;
    });
  }
  return widths;
};

var useCellRenderer = function useCellRenderer(_ref2) {
  var recomputeGridSize = _ref2.recomputeGridSize,
      columns = _ref2.columns,
      width = _ref2.width,
      includeHeaders = _ref2.includeHeaders,
      data = _ref2.data,
      columnWidth = _ref2.columnWidth,
      isCellHovered = _ref2.isCellHovered,
      isCellSelected = _ref2.isCellSelected,
      isCellDisabled = _ref2.isCellDisabled,
      classes = _ref2.classes,
      orderBy = _ref2.orderBy,
      orderDirection = _ref2.orderDirection,
      onHeaderClick = _ref2.onHeaderClick,
      onCellClick = _ref2.onCellClick,
      onCellDoubleClick = _ref2.onCellDoubleClick,
      onCellContextMenu = _ref2.onCellContextMenu,
      resizable = _ref2.resizable,
      defaultCellProps = _ref2.cellProps;

  var _React$useState = _react2.default.useState({
    hoveredColumn: null,
    hoveredRowData: null
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      _React$useState2$ = _React$useState2[0],
      hoveredColumn = _React$useState2$.hoveredColumn,
      hoveredRowData = _React$useState2$.hoveredRowData,
      setHovered = _React$useState2[1];

  var _React$useState3 = _react2.default.useState(calculateWidths({ resizable: resizable, columns: columns })),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      widths = _React$useState4[0],
      setWidths = _React$useState4[1];

  _react2.default.useEffect(function () {
    recomputeGridSize();
  }, [recomputeGridSize, hoveredColumn, hoveredRowData, widths]);

  var resizableColumnWidths = _react2.default.useCallback(function (index, columns, tableWidth) {
    return widths[columns[index].name] * tableWidth;
  }, [widths]);

  var getColumnWidth = _react2.default.useCallback(function (_ref3) {
    var index = _ref3.index;
    return typeof columnWidth === 'function' ? columnWidth({ index: index, columns: columns, width: width }) : resizable ? resizableColumnWidths(index, columns, width) : (0, _utils.calcColumnWidth)(index, columns, width);
  }, [columnWidth, resizable, columns, width, resizableColumnWidths]);

  var resizeRow = _react2.default.useCallback(function (_ref4) {
    var dataKey = _ref4.dataKey,
        deltaX = _ref4.deltaX;
    return setWidths(function (prev) {
      var _extends2;

      var delta = deltaX / width;
      var index = columns.findIndex(function (c) {
        return c.name === dataKey;
      });
      var nextDataKey = columns[index + 1].name;
      return _extends({}, prev, (_extends2 = {}, _defineProperty(_extends2, dataKey, prev[dataKey] + delta), _defineProperty(_extends2, nextDataKey, prev[nextDataKey] - delta), _extends2));
    });
  }, [setWidths, columns, width]);

  var handleDrag = _react2.default.useCallback(function (dataKey) {
    return function (event, _ref5) {
      var deltaX = _ref5.deltaX;
      return resizeRow({
        dataKey: dataKey,
        deltaX: deltaX
      });
    };
  }, [resizeRow]);

  var handleMouse = _react2.default.useCallback(function (hoveredColumn, hoveredRowData) {
    return function (e) {
      return setHovered({
        hoveredColumn: hoveredColumn,
        hoveredRowData: hoveredRowData
      });
    };
  }, [setHovered]);

  var cellRenderer = function cellRenderer(_ref6) {
    var _classNames;

    var columnIndex = _ref6.columnIndex,
        rowIndex = _ref6.rowIndex,
        key = _ref6.key,
        style = _ref6.style;

    var column = columns[columnIndex];
    var isHeader = includeHeaders && rowIndex === 0;
    var headerOffset = includeHeaders ? 1 : 0;
    var rowData = data && data[rowIndex - headerOffset] || {};

    var isSelected = isCellSelected && isCellSelected(column, rowData);
    var isDisabled = isCellDisabled && isCellDisabled(column, rowData);

    var isHovered = hoveredColumn && hoveredRowData && isCellHovered && isCellHovered(column, rowData, hoveredColumn, hoveredRowData);

    var resolveCellProps = function resolveCellProps(cellProps) {
      return typeof cellProps === 'function' ? cellProps(column, rowData, hoveredColumn, hoveredRowData) : cellProps;
    };
    // TODO: Deep merge (do not override all defaultCellProps styles if column.cellProps.styles defined?)

    var _resolveCellProps$res = _extends({}, resolveCellProps(defaultCellProps), resolveCellProps(column.cellProps)),
        cellStyle = _resolveCellProps$res.style,
        cellProps = _objectWithoutProperties(_resolveCellProps$res, ['style']);

    var contents = _react2.default.createElement(
      'div',
      { className: classes.cellContents },
      _react2.default.createElement(
        'span',
        { style: { flex: 'auto' } },
        isHeader ? column.header != null ? column.header : column.name : column.cell ? column.cell(rowData) : rowData[column.name]
      ),
      _react2.default.createElement(
        'span',
        { style: { float: 'right' } },
        isHeader && resizable && columnIndex < columns.length - 1 && _react2.default.createElement(
          _reactDraggable2.default,
          {
            axis: 'x',
            defaultClassName: classes.dragHandle,
            defaultClassNameDragging: classes.DragHandleActive,
            onDrag: handleDrag(column.name),
            position: { x: 0 }
          },
          _react2.default.createElement(
            'span',
            { className: classes.DragHandleIcon },
            '\u22EE'
          )
        )
      )
    );

    var hasCellClick = !isHeader && onCellClick;
    var hasCellDoubleClick = !isHeader && onCellDoubleClick;
    var hasCellContextMenu = !isHeader && onCellContextMenu;
    var isClickable = hasCellClick || hasCellDoubleClick || hasCellContextMenu || column.onClick;

    var className = (0, _classnames2.default)(classes.cell, (_classNames = {}, _defineProperty(_classNames, classes.cellClickable, isClickable), _defineProperty(_classNames, classes.cellHovered, isHovered), _defineProperty(_classNames, classes.cellSelected, isSelected), _defineProperty(_classNames, classes.cellDisabled, isDisabled), _defineProperty(_classNames, classes.cellHeader, isHeader), _defineProperty(_classNames, classes.cellInLastColumn, columnIndex === columns.length - 1), _defineProperty(_classNames, classes.cellInLastRow, !isHeader && rowIndex === (data ? data.length : 0)), _classNames));

    return _react2.default.createElement(
      _TableCell2.default,
      _extends({
        component: 'div',
        className: className,
        key: key,
        onMouseEnter: handleMouse(column, rowData),
        onMouseLeave: handleMouse(null, null),
        style: _extends({}, style, cellStyle)
      }, hasCellClick && {
        onClick: function onClick(event) {
          return onCellClick(event, { column: column, rowData: rowData, data: data });
        }
      }, hasCellDoubleClick && {
        onDoubleClick: function onDoubleClick(event) {
          return onCellDoubleClick(event, { column: column, rowData: rowData, data: data });
        }
      }, hasCellContextMenu && {
        onContextMenu: function onContextMenu(event) {
          return onCellContextMenu(event, { column: column, rowData: rowData, data: data });
        }
      }, cellProps),
      isHeader && column.onHeaderClick !== false && (column.onHeaderClick || onHeaderClick) ? _react2.default.createElement(
        _TableSortLabel2.default,
        {
          active: orderBy && (orderBy === column.name || orderBy === column.orderBy) && rowIndex === 0,
          style: { width: 'inherit' } // fix text overflowing
          , direction: orderDirection,
          onClick: function onClick(event) {
            return column.onHeaderClick ? column.onHeaderClick(event, { column: column }) : onHeaderClick(event, { column: column });
          }
        },
        contents
      ) : isHeader && column.resizable ? _react2.default.createElement(
        _react2.default.Fragment,
        null,
        contents,
        _react2.default.createElement(
          _reactDraggable2.default,
          {
            axis: 'x',
            defaultClassName: 'DragHandle',
            defaultClassNameDragging: 'DragHandleActive',
            onDrag: handleDrag(column.name),
            position: { x: 0 }
          },
          _react2.default.createElement(
            'span',
            { className: 'DragHandleIcon' },
            '\u22EE'
          )
        )
      ) : contents
    );
  };

  return { cellRenderer: cellRenderer, columnWidth: getColumnWidth };
};

function MuiTable(_ref7) {
  var data = _ref7.data,
      columns = _ref7.columns,
      width = _ref7.width,
      height = _ref7.height,
      _ref7$maxHeight = _ref7.maxHeight,
      maxHeight = _ref7$maxHeight === undefined ? null : _ref7$maxHeight,
      pagination = _ref7.pagination,
      fitHeightToRows = _ref7.fitHeightToRows,
      _ref7$fixedRowCount = _ref7.fixedRowCount,
      fixedRowCount = _ref7$fixedRowCount === undefined ? 0 : _ref7$fixedRowCount,
      _ref7$fixedColumnCoun = _ref7.fixedColumnCount,
      fixedColumnCount = _ref7$fixedColumnCoun === undefined ? 0 : _ref7$fixedColumnCoun,
      _ref7$rowHeight = _ref7.rowHeight,
      rowHeight = _ref7$rowHeight === undefined ? 48 : _ref7$rowHeight,
      style = _ref7.style,
      columnWidth = _ref7.columnWidth,
      _ref7$includeHeaders = _ref7.includeHeaders,
      includeHeaders = _ref7$includeHeaders === undefined ? false : _ref7$includeHeaders,
      isCellHovered = _ref7.isCellHovered,
      isCellSelected = _ref7.isCellSelected,
      isCellDisabled = _ref7.isCellDisabled,
      Classes = _ref7.classes,
      orderBy = _ref7.orderBy,
      orderDirection = _ref7.orderDirection,
      onHeaderClick = _ref7.onHeaderClick,
      onCellClick = _ref7.onCellClick,
      onCellDoubleClick = _ref7.onCellDoubleClick,
      onCellContextMenu = _ref7.onCellContextMenu,
      resizable = _ref7.resizable,
      cellProps = _ref7.cellProps,
      other = _objectWithoutProperties(_ref7, ['data', 'columns', 'width', 'height', 'maxHeight', 'pagination', 'fitHeightToRows', 'fixedRowCount', 'fixedColumnCount', 'rowHeight', 'style', 'columnWidth', 'includeHeaders', 'isCellHovered', 'isCellSelected', 'isCellDisabled', 'classes', 'orderBy', 'orderDirection', 'onHeaderClick', 'onCellClick', 'onCellDoubleClick', 'onCellContextMenu', 'resizable', 'cellProps']);

  var classes = useStyles({ classes: Classes });
  var theme = (0, _styles.useTheme)();

  var multiGrid = _react2.default.useRef(null);

  var recomputeGridSize = _react2.default.useCallback(function () {
    return multiGrid.current && multiGrid.current.recomputeGridSize();
  }, [multiGrid]);

  _react2.default.useEffect(function () {
    recomputeGridSize();
  }, [columns, data, height, width, recomputeGridSize]);

  var calculatedHeight = 0;
  if (height) {
    calculatedHeight = height; // fixed height
  } else if (pagination && pagination.rowsPerPage && !fitHeightToRows) {
    var rowCount = pagination.rowsPerPage + (fixedRowCount ? fixedRowCount : includeHeaders ? 1 : 0);
    calculatedHeight = rowCount * rowHeight;
  } else if (Array.isArray(data)) {
    var _rowCount = data.length + (fixedRowCount ? fixedRowCount : includeHeaders ? 1 : 0);
    calculatedHeight = _rowCount * rowHeight;
  }

  var paginationHeight = theme.mixins.toolbar.minHeight + FOOTER_BORDER_HEIGHT;

  var calculatedHeightWithFooter = calculatedHeight + (pagination ? paginationHeight : 0);
  var containerHeight = maxHeight != null ? Math.min(calculatedHeightWithFooter, maxHeight) : calculatedHeightWithFooter;
  var multiGridHeight = containerHeight - (pagination ? paginationHeight : 0);

  return _react2.default.createElement(
    _Table2.default,
    _extends({
      component: 'div',
      style: _extends({ width: width, height: containerHeight }, style),
      className: classes.table
    }, other),
    _react2.default.createElement(_MultiGrid2.default, _extends({}, useCellRenderer({
      recomputeGridSize: recomputeGridSize,
      data: data,
      columns: columns,
      width: width,
      classes: classes,
      includeHeaders: includeHeaders,
      columnWidth: columnWidth,
      isCellHovered: isCellHovered,
      isCellSelected: isCellSelected,
      isCellDisabled: isCellDisabled,
      orderBy: orderBy,
      orderDirection: orderDirection,
      onHeaderClick: onHeaderClick,
      onCellClick: onCellClick,
      onCellDoubleClick: onCellDoubleClick,
      onCellContextMenu: onCellContextMenu,
      resizable: resizable,
      cellProps: cellProps
    }), {
      ref: multiGrid,
      width: width,
      columnCount: Array.isArray(columns) ? columns.length : 0,
      fixedColumnCount: fixedColumnCount,
      enableFixedColumnScroll: fixedColumnCount > 0,
      height: multiGridHeight,
      rowHeight: rowHeight,
      rowCount: Array.isArray(data) ? data.length + (includeHeaders ? 1 : 0) : 0,
      fixedRowCount: fixedRowCount,
      enableFixedRowScroll: fixedRowCount > 0
      // TODO: Read these from `classes` without classes.table inheritance?  How to pass props.classes down to override?
      , classNameTopLeftGrid: 'topLeftGrid',
      classNameTopRightGrid: 'topRightGrid',
      classNameBottomLeftGrid: 'bottomLeftGrid',
      classNameBottomRightGrid: 'bottomRightGrid'
    })),
    pagination && _react2.default.createElement(
      _TableFooter2.default,
      { component: 'div', className: classes.footer },
      _react2.default.createElement(_TablePagination2.default, _extends({ component: 'div' }, pagination))
    )
  );
}

MuiTable.propTypes = {
  data: _propTypes2.default.array,
  columns: _propTypes2.default.array,
  width: _propTypes2.default.number,
  height: _propTypes2.default.number,
  maxHeight: _propTypes2.default.number,
  pagination: _propTypes2.default.object,
  fitHeightToRows: _propTypes2.default.bool,
  fixedRowCount: _propTypes2.default.number,
  fixedColumnCount: _propTypes2.default.number,
  rowHeight: _propTypes2.default.number,
  columnWidth: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.func]),
  includeHeaders: _propTypes2.default.bool,
  orderBy: _propTypes2.default.string,
  orderDirection: _propTypes2.default.string,
  onHeaderClick: _propTypes2.default.func,
  onCellClick: _propTypes2.default.func,
  onCellDoubleClick: _propTypes2.default.func,
  onCellContextMenu: _propTypes2.default.func,
  noPointer: _propTypes2.default.bool,
  isCellHovered: _propTypes2.default.func,
  isCellSelected: _propTypes2.default.func,
  isCellDisabled: _propTypes2.default.func,
  classes: _propTypes2.default.object,
  cellProps: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func]),
  style: _propTypes2.default.object
};